<?php
# api: phrep
# title: HTML@ macro


namespace macro;

/**
 * Custom macro callback for raw HTML output with escaped vars.
 *
 * Use via:
 *    HTML@(<a href=$link>$title</a>)
 *
 */
$proc->d_define("HTML@(raw)=return macro\\HTML(\$token);");
function HTML($token) {
    $code = [];
    foreach (\io\Token::split_expr($token) as $pair) {
        list($html, $var) = $pair;
        $code[] = var_export($html, 1);
        if ($var) {
            $var = "htmlspecialchars({$var}, ENT_QUOTES)";
            $code[] = $var;
        }
    }
    return join(" . ", $code);
}


