<?php
# api: phrep
# title: Simple qw@ macro
# description: Expands a word list into an array
#
# Similar to Perls qw() this macro expands a space-delimited list
# of words into a standard array.
#
# Use via:
#    qw@(foo bar baz)
#
# Generates:
#    ['foo', 'bar', 'baz']
#
# As exception to the rule uses a lowercase macro name.
# Also available within `defaults.ph` as compacter #define rule.


namespace macro;
$proc->defines["qw"] = [["words"], "return macro\\qw(\$token);"];

/**
 * Expand word list into array.
 *
 */
function qw($token) {
    return "[" . join(", ",
        array_map(
             function($word) {
                 return var_export($word, TRUE);
             },
             preg_split(
                 "/\s+/",
                 trim(\io\Token::join($token))
             )
         )
    ) . "]";
}

