<?php
# t: runthrough
# description: #define const/macro extraction

// empty constant list
$proc = new io\MacroProcessor([__DIR__], [
]);

// Expressions to check
$probe = [
    "#define X 1.1.11"               => ["X", ["", "1.1.11"]],
    "#define V \"2\""                => ["V", ["", "\"2\""]],
    "#define M(a) a+a"               => ["M", [["a"], "a+a"]],
    "#define M(a,b) a+b"             => ["M", [["a","b"], "a+b"]],
    "#define M(a,b) a+b"             => ["M", [["a","b"], "a+b"]],
    "#define CX@(a,b) {\$a.\$b}"     => ["CX@", [["a","b"], '{$a.$b}']],
    "#define Z1(varg...) varg"       => ["Z1", [["varg..."], "varg"]],
    "#define Z2(x,varg...) #varg"    => ["Z2", [["x","varg..."], "#varg"]],
    "#define Z3(varg...,i) ##varg"   => ["Z3", [["varg...","i"], "##varg"]],
    "#define Z4(...wrongargs) -"     => ["Z4", NULL],
    "#define U0 1"                   => ["U0", [null, 1]],
    "#undef U0"                      => ["U0", NULL],
];

// stub
#set_error_handler(function($i, $msg) { print "$msg";});

// Compare results
foreach ($probe as $src=>$val) {
    list($name, $data) = $val;
    print "\e[2m$src\e[0m == ";
    //@in io\MacroExpression::expr $tokens, each, is_string
    //@in io\MacroExpression::group $var, each, is_scalar
    //@in io\MacroExpression::group $ops, end, empty
    //@in io\MacroExpression::run $sum, each, is_numeric
    //@in io\MacroExpression::run $opvals, end, empty
    $proc->block("\rpre..\n$src\r\ntxt..\n");

    $r = isset($proc->defines[$name])
       ? $proc->defines[$name] 
       : NULL;
    printf("\e[33m%s\e[0m ", json_encode($r));

    if ($r == $data) {
        print "\e[1;32m(DEF)\e[0m\n";
    }
    if ($proc->defines[$name] != $data) {
        print "\e[31m(F)\e[0m \n"; 
    }
}


